import React, { Component } from 'react'
//import 'dhtmlx-gantt'
//import 'dhtmlx-gantt/codebase/dhtmlxgantt.css'

import ContentManager from '../content-manager'
import AcaoEdit from '../../paginas/acao/edit'



export default class Gantt extends React.Component {

  setZoom(value){
    switch (value){
      case 'Hours':
        gantt.config.scale_unit = 'day'
        gantt.config.date_scale = '%d %M'

        gantt.config.scale_height = 60
        gantt.config.min_column_width = 30
        gantt.config.subscales = [
          {unit:'hour', step:1, date:'%H'}
        ]
        break
      case 'Days':
        gantt.config.min_column_width = 70
        gantt.config.scale_unit = "week"
        gantt.config.date_scale = "#%W"
        gantt.config.subscales = [
          {unit: "day", step: 1, date: "%d %M"}
        ]
        gantt.config.scale_height = 60
        break
      case 'Months':
        gantt.config.min_column_width = 70
        gantt.config.scale_unit = "month"
        gantt.config.date_scale = "%F"
        gantt.config.scale_height = 60
        gantt.config.subscales = [
          {unit:"week", step:1, date:"#%W"}
        ]
        break
      default:
        break
    }
  }

  shouldComponentUpdate(nextProps){

	
    if (this.props.tasks.data.length !== nextProps.tasks.data.length){
      return true
    }
    if (this.props.zoom !== nextProps.zoom){
      return true
    }
    else {return false}
  }

  componentDidUpdate() {
    gantt.render()
  }



  // 
  handleCheckBox(){
    return "checkbox-blank-circle"
  }
  // I can't make it work! =/
  handleFarol(obj) {
    return "<div><MdiIcon icon={this.handleCheckBox} size={20} color={obj.farol_acao.cor} colorHover={obj.farol_acao.cor} title={obj.farol_acao.icone}/></div>"
  }

  componentDidMount() {
    gantt.config.columns =  [
      {resize:true, name:"text", label:"Ação",align:"left",  tree:true,width:"100" },
      {resize:true, name:"codigo", label:"Código", align:"center", width:"40"},
      {resize:true, name:"start_date", label:"Data Início", align: "center", width:"60" },
      {resize:true, name:"end_date",   label:"Data Término",   align: "center",width:"80" },
      {resize:true, name:"farol_acao",   label:"Faról",   align: "center",width:"40", template:this.handleFarol},
      {resize:true, name: "add", label: "", width: 36, hide:true}, // botão de adicionar nova ação
      {resize:true, name:"progress",   label:"% Realizado", align: "center", width:"80" },
      {resize:true, name:"holder",     label:"Responsável", align: "center",width:"70" },
      {resize:true, name:"percentual_previsto", label:"% Previsto", align:"center",width:"80"},
      {resize:true, name:"status_acao", label:"Status", align:"center",width:"90"},
      {resize:true, name:"baseline_inicial", label:"Baseline Inicial", align:"center",width:"80"},
      {resize:true, name:"baseline_final", label:"Baseline Final", align:"center",width:"80"},
      {resize:true, name:"data_inicio_realizada", label:"Data Inicial Realizada", align:"center",width:"80"},
      {resize:true, name:"data_fim_realizada", label:"Data Final Realizada", align:"center"},
      {resize:true, name:"observacao", label:"Observação", align:"center"},
      {resize:true, name:"como", label:"Como", align:"center"},
      {resize:true, name:"onde", label:"Onde", align:"center"},
      {resize:true, name:"porque", label:"Porque", align:"center"}
    ]

    gantt.attachEvent('onAfterTaskAdd', (id, task) => {
      if(this.props.onTaskUpdated) {
        this.props.onTaskUpdated(id, 'inserted', task)
      }
    })

    gantt.attachEvent('onAfterTaskUpdate', (id, task) => {
      if(this.props.onTaskUpdated) {
        this.props.onTaskUpdated(id, 'updated', task)
      }
    })

    gantt.attachEvent('onAfterTaskDelete', (id) => {
      if(this.props.onTaskUpdated) {
        this.props.onTaskUpdated(id, 'deleted')
      }
    })

    gantt.attachEvent('onAfterLinkAdd', (id, link) => {
      if(this.props.onLinkUpdated) {
        this.props.onLinkUpdated(id, 'inserted', link)
      }
    })

    gantt.attachEvent('onAfterLinkUpdate', (id, link) => {
      if(this.props.onLinkUpdated) {
        this.props.onLinkUpdated(id, 'updated', link)
      }
    })

    gantt.attachEvent('onAfterLinkDelete', (id, link) => {
      if(this.props.onLinkUpdated) {
        this.props.onLinkUpdated(id, 'deleted')
      }
    })

    gantt.attachEvent('onTaskDblClick', (id, link) => {
      let task = gantt.getTask(id)
      ContentManager.addContent(<AcaoEdit item={task} id={id}></AcaoEdit>)
    })

    //gantt.config.autosize = "xy"
    gantt.config.date_grid = "%d/%m"  //formato da data no grid
    gantt.config.drag_resize = false // não consegue redimensionar pela barra
    gantt.config.grid_width = 1000 //largura grid
    gantt.config.smart_scales = true
    gantt.config.grid_resize = true
    gantt.config.autofit = false

    gantt.config.layout = {
      css: "gantt_container",
      rows:[
        {
          cols: [
            {view: "grid", id: "grid", scrollX:"scrollHor", scrollY:"scrollVer"},
            {resizer: true, width: 1},
            {view: "timeline", id: "timeline", scrollX:"scrollHor", scrollY:"scrollVer"},
            {view: "scrollbar", scroll: "y", id:"scrollVer"}
          ]
        },
        {view: "scrollbar", scroll: "x", id:"scrollHor", height:20}
      ]
    }

    gantt.init(this.ganttContainer)
    gantt.parse(this.props.tasks)
  }

  render() {
    this.setZoom(this.props.zoom)
    return (
        <div
            ref={(input) => { this.ganttContainer = input }}
            style={{width: '100%', height: '700'}}
        ></div>
    )
  }
}
